var fs=require('fs'),path=require('path'),argc=process.argv.slice(2),_l=console.log;
var _f=fs.readdirSync('.'),_c=null,_i=null,_j=[],_t=[],p=[],_o=0,_p='',_b=[];//dir,buf,size,offset,tmd,temp,offset,path,buf
var SetHex=function(num,bytes) {var a=new Buffer(bytes); for(var i=0;i<bytes;i++){a[i]=num%0x100;num=(num-a[i])/0x100;} return a;}, GLEHex=function(buf,off,bytes){var t=0;for(var i=0;i<bytes;i++){t*=0x100;t+=buf[off+bytes-1-i];}return t;},GBEHex=function(buf,off,bytes){var t=0;for(var i=0;i<bytes;i++){t=t*256+buf[off+i];}return t;};
var PrintXY = function(num,chars) {var _r=num.toString(16).toUpperCase();while(_r.length < chars) {_r='0'+_r;}return _r;};
var CalPad=function(num,pad){var _r=num%pad,a=num;if(_r>0)a=a-_r+pad;return a;};
var OutHex=function(buf,off,len) {var a='';for(var i=0;i<len;i++)a+=PrintXY(buf[off+i],2);return a;};
var DupBuf=function(buf,off,len) {var a=new Buffer(len);for(var i=0;i<len;i++)a[i]=buf[i+off];return a;};
_l('[INFO]Raw CDN CIA Unpacker. Run this script within the folder containing CDN CIAs.');
_l('[WARN]Never run this within a folder contains ever decrypted CIAs!');
var record=[],xmlfile='',xmlpart='<TitleVersion><TitleId>#0</TitleId><Version>#1</Version><FsSize>#2</FsSize><TicketSize>#3</TicketSize><TMDSize>#4</TMDSize></TitleVersion>';
for (var i=0;i<_f.length;i++){
	if (_f[i].match(/\.cia$/)==null) continue;
	_c=fs.readFileSync(_f[i]);
	_i=[GLEHex(_c,0x08,0x04),GLEHex(_c,0x0C,0x04),GLEHex(_c,0x10,0x04),GLEHex(_c,0x14,0x04),GLEHex(_c,0x18,0x08)];
	_l('[SIZE]'+_f[i]+': Cert '+PrintXY(_i[0],8)+', Tick '+PrintXY(_i[1],8)+', TMDs '+PrintXY(_i[2],8)+', Meta '+PrintXY(_i[3],8)+', Cont '+PrintXY(_i[4],8)+'.');
	_j[0]=0x2020+0x20;	//Cert
	_j[1]=CalPad(_j[0]+_i[0],0x20); //Ticket
	_j[2]=CalPad(_j[1]+_i[1],0x20)+0x20; //TMD
	_j[3]=CalPad(_j[2]+_i[2],0x20); //Meta
	_j[4]=CalPad(_j[3]+_i[3],0x20); //Content
	_l('[OFF:]'+_f[i]+': Cert '+PrintXY(_j[0],8)+', Tick '+PrintXY(_j[1],8)+', TMDs '+PrintXY(_j[2],8)+', Meta '+PrintXY(_j[3],8)+', Cont '+PrintXY(_j[4],8)+'.');
	//Read the TMD
	_t[0]=GBEHex(_c,_j[2],4);//Signature Type.
	switch(_t[0]){
		case 0x00010000: //RSA 4096 SHA1, Unused.
			_t[1]=_j[2]+0x04+0x200+0x3C; break;
		case 0x00010001: //RSA 2048 SHA1. Unused.
			_t[1]=_j[2]+0x04+0x100+0x3C; break;
		case 0x00010002: //Elliptic Curve with SHA1. Unused.
			_t[1]=_j[2]+0x04+0x3C+0x40; break;
		case 0x00010003: //RSA 4096 SHA256
			_t[1]=_j[2]+0x04+0x200+0x3C; break;
		case 0x00010004: //RSA 2048 SHA256
			_t[1]=_j[2]+0x04+0x100+0x3C; break;
		case 0x00010005: //ECDSA SHA256
			_t[1]=_j[2]+0x04+0x3C+0x40; break;
	}
	_t[2]=GBEHex(_c,_t[1]+0x9C,2); //Title Version
	_t[5]=GBEHex(_c,_t[1]+0x4C,8); //Title ID
	_t[3]=GBEHex(_c,_t[1]+0x9E,2); //Content Count
	_t[4]=_t[1]+0xC4+0x24*0x40; //Content Chunk.
	_l('[TMD:]Title ID @ '+PrintXY(_t[1]+0x4C,8)+'='+PrintXY(_t[5],16)+', Version @ '+PrintXY(_t[1]+0x9C,8)+'='+PrintXY(_t[2],4)+', Content Count @ '+PrintXY(_t[1]+0x9E,8)+'='+PrintXY(_t[3],4));
	//Dump the TMD and CETK.
	//_p=_f[i].replace(/\.cia$/,'');
	_p=OutHex(_c,_j[2]+0x18C,8);
	if (!fs.existsSync(_p)) fs.mkdirSync(_p);
	//fs.writeFileSync(_p+'/cert', DupBuf(_c,_j[0],_i[0]));
	if (_b.length==0) {
		_b[0]=DupBuf(_c,_j[0]+0x000,0x400); //CA00000003
		_b[1]=DupBuf(_c,_j[0]+0x400,0x300); //XS0000000c
		_b[2]=DupBuf(_c,_j[0]+0x700,0x300); //CP0000000b
	}
	//_l('[DUMP]Dump TMD  '+PrintXY(_j[2],8)+'+'+PrintXY(_i[2],8)+'. Cert: CP0000000b and CA00000003.');
	fs.writeFileSync(_p+'/tmd.'+_t[2], DupBuf(_c,_j[2],_i[2]));
	fs.appendFileSync(_p+'/tmd.'+_t[2], _b[2]);
	fs.appendFileSync(_p+'/tmd.'+_t[2], _b[0]);
	fs.writeFileSync(_p+'/tmd',fs.readFileSync(_p+'/tmd.'+_t[2])); //Duplicate one to tmd.
	//_l('[DUMP]Dump CETK '+PrintXY(_j[1],8)+'+'+PrintXY(_i[1],8)+'. Cert: XS0000000c and CA00000003 .');
	fs.writeFileSync(_p+'/cetk', DupBuf(_c,_j[1],_i[1]));
	fs.appendFileSync(_p+'/cetk', _b[1]);
	fs.appendFileSync(_p+'/cetk', _b[0]);
	//Generate a Base64 one for XML
	fs.writeFileSync(_p+'/cetk.base64',DupBuf(_c,_j[1],_i[1]).toString('base64'));
	//Dump Contents
	_o=_j[4];
	for (var j=0;j<_t[3];j++){
		p[0]=GBEHex(_c,_t[4]+j*0x30,4); //Content ID
		p[1]=GBEHex(_c,_t[4]+j*0x30+0x04,2); //Content Index
		p[2]=GBEHex(_c,_t[4]+j*0x30+0x06,2); //Content Type
		p[3]=GBEHex(_c,_t[4]+j*0x30+0x08,8); //Content Size
		p[4]=OutHex(_c,_t[4]+j*0x30+0x10,0x20); //Content HASH
		p[5]=_o;_o+=p[3];
		_l('[CNT:]Content #'+PrintXY(p[0],8)+'@'+PrintXY(p[5],8)+':'+PrintXY(p[1],4)+'!'+PrintXY(p[2],4)+'='+PrintXY(p[3],8)+', '+p[4]);
		fs.writeFileSync(_p+'/'+PrintXY(p[0],8),DupBuf(_c,p[5],p[3]));
	}
	//Build XML Content. TODO:: I don't know how the FsSize is calculated.
	record.push([_t[5],[PrintXY(_t[5],16),_t[2],_i[4],_i[1],fs.lstatSync(_p+'/tmd').size]]);
}
record=record.sort(function(a,b){return a[0]-b[0];});
for (var i=0;i<record.length;i++) {
	xmlfile+=xmlpart.replace(/\#0/g,record[i][1][0]).replace(/\#1/g,record[i][1][1])
		.replace(/\#2/g,record[i][1][2]).replace(/\#3/g,record[i][1][3]).replace(/\#4/g,record[i][1][4]);
}
fs.writeFileSync('GetSystemUpdate.partial.xml',xmlfile);
_l('[INFO]Congratulations. All CIAs unpacked. Partial XML Length: '+xmlfile.length+', with '+record.length+' entries.');
